<!--
	FILE FROM WWW.CFTUTORIALS.COM - 
	YOUR USE OF THIS FILE SIGNIFIES YOUR AGREEMENT TO BE BOUND BY THE TERMS AND CONDITIONS:
	http://www.cftutorials.com/index.cfm?mode=contentpage&element=terms_and_conditions
-->

<CFSET SESSION.LOGGEDIN = FALSE>

<CFQUERY NAME="CheckUser" DATASOURCE="Database">
	SELECT UserID, Password
	FROM passwords
	WHERE UserID = '#Form.UserID#'
</CFQUERY>

<!-- Is the user present in the database? -->
<CFIF CHECKUSER.RECORDCOUNT GREATER THAN 0>

	<!--- Passwords are not case-sensitive in this application (use Compare() if you want to enable case sensitivity) --->
	<CFIF CHECKUSER.PASSWORD IS FORM.PASSWORD>
		
		<!-- Does the application structure exist? If not, create one -->
		<CFIF #ISDEFINED("application.UsersLoggedin")# IS FALSE>
			<CFSET APPLICATION.USERSLOGGEDIN=STRUCTNEW()>
		</CFIF>
		
		<CFSET USERIDATDOOR = CHECKUSER.USERID>
		<!-- Is there a user already using this login? -->
		<CFIF #STRUCTKEYEXISTS(APPLICATION.USERSLOGGEDIN, USERIDATDOOR)# IS TRUE>
			<!-- If so, we check if the session is 'virtually' timed out -->
			<CFSET ENDTIME = #APPLICATION.USERSLOGGEDIN[USERIDATDOOR].TIMECREATED# + #APPTIMESPAN#>
			<CFIF #DATECOMPARE("#Now()#", "#EndTime#")# IS 1>
				<!-- If the application variable is timed out then we delete the user from the structure, to leave some room for the new user -->
				<CFOUTPUT>
				<CFSCRIPT>
				StructDelete(application.UsersLoggedin, #CheckUser.UserID#, true);
				</CFSCRIPT>
				</CFOUTPUT>
				
				<!-- These Session variables are used to control the login validity through the application using the application.cfm -->
				<CFSET SESSION.LOGGEDIN = TRUE>
				<CFSET SESSION.USERID = CHECKUSER.USERID>
	
				<!-- We then add the current user session structure to the Application structure -->
				<CFSET APPLICATION.USERSLOGGEDIN["#session.UserID#"] = SESSION>
				<!-- We add a time stamp to determinate the approximate timeout in case of an unexpected departure of the user -->
				<CFSET APPLICATION.USERSLOGGEDIN["#Session.UserID#"].TIMECREATED = NOW()> 
				
			<CFELSE>
				<!-- If the session of the user currently logged in is not over, we display a message -->
				<CFOUTPUT>
				<CFIF #DATEDIFF("n", "#Now()#", "#EndTime#")# LT 1>
					<CFSET MINUTESLEFT = 'LESS THAN ONE'>
				<CFELSE>
					<CFSET MINUTESLEFT = #DATEDIFF("n", "#Now()#", "#EndTime#")#>
				</CFIF>
				<CFSET REASON = ": \n\n1- User #CheckUser.UserID# is already logged-in.\n2- OR you have terminated your last session abnormaly (e.g. your computer crashed).\n\nThis account will be unlocked in: #MinutesLeft# minute(s) from now.\n\nTo obtain more licenses, please contact our sales team.">
				</CFOUTPUT>	
			</CFIF>
		
		<!-- if we don't detect any user already logged in with the same login, we give the user access to the application -->
		<CFELSE>
			<!-- These Session variables are used to control the login validity through the application using the application.cfm -->
			<CFSET SESSION.LOGGEDIN = TRUE>
			<CFSET SESSION.USERID = CHECKUSER.USERID>

			<!-- We then add the current user session structure to the Application structure -->
			<CFSET APPLICATION.USERSLOGGEDIN["#session.UserID#"] = SESSION>
			<!-- We add a time stamp to determinate the approximate timeout in case of an unexpected departure of the user -->
			<CFSET APPLICATION.USERSLOGGEDIN["#Session.UserID#"].TIMECREATED = NOW()> 

		</CFIF>
	
	<!-- if the password was incorrect -->
	<CFELSE>
		<CFSET REASON = "the password you\'ve typed is invalid. Try again">
	</CFIF>
	
<!-- if the username was not present in the database -->	
<CFELSE>
	<CFOUTPUT>
	<CFSET REASON = 'I COULD NOT FIND A USER NAMED #FORM.USERID# HERE.'>
	</CFOUTPUT>
</CFIF>
	
<!-- If the user is authenticated we transfer him/her to the homepage -->
<CFIF SESSION.LOGGEDIN>

	<SCRIPT LANGUAGE="JavaScript">
	self.location ='page1.cfm';
	</SCRIPT>

<!-- If not we transfer the user to the login page -->
<CFELSE>
	<CFOUTPUT>
	<SCRIPT>
	alert("Sorry!  Your login was unsuccessful because #Reason#");
	self.location="login.cfm";
	</SCRIPT>	
	</CFOUTPUT>

</CFIF>